/*
 * Hormann, Leydold, Derflinger
 * Automatic Nonuniform Random Variate Generation
 * Springer, Heidelberg, New York, 2003
 * http://statistik.wu-wien.ac.at/arvag/monograph
 * 
 * Code for Algorithm 3.1 (Sequential-Search), p. 44 
 *
 * this file: algo03_01.c
 *
 * For a demo how to use this algorithm see the file "demo_algo03_01.c".
 *
 */

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "uniform.h"

int generator03_01(double (*pmf)(int))
/*
 * Algorithm 3.1 (Sequential-Search), p. 44  
 * generates discrete variates
 *
 * pmf... function pointer to probability (mass) function for k >= 0
 */
{ double u, p;
  int x;

/*1*/  u = uniform();
/*2*/  x = 0;
       p = (*pmf)(0);
/*3*/  while(u > p){
/*4*/    x = x + 1;
         p = p + (*pmf)(x);}
/*5*/  return x;
}




