/*
 * Hormann, Leydold, Derflinger
 * Automatic Nonuniform Random Variate Generation
 * Springer, Heidelberg, New York, 2003
 * http://statistik.wu-wien.ac.at/arvag/monograph
 * 
 * Code for Algorithm 9.1 (Hazard Rate Inversion), p. 195 
 *
 * this file: algo09_01.c
 *
 * For a demo how to use this algorithm see the file "demo_algo09_01.c".
 *
 */

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "uniform.h"

double generator09_01(double (*ich)(double))
/*
 * Algorithm 9.1 (Hazard Rate Inversion), p. 195 
 *
 * ich... function pointer to the inverse cumulative hazard rate
 */
{ 
      double x, e;

/*1*/ e = -log(1.-uniform());
/*2*/ x = (*ich)(e);
/*3*/ return x;

}




